% read image
img = im2double(imread('peppers.png'));
[ny,nx,nc]=size(img);

% build discrete gradient in matrix form
D = buildGradient(ny,nx,nc);

% apply (I + detla * D'D), to a testimage
delta = 5;
test = reshape(img(:) + delta*D'*(D*img(:)), [ny,nx,nc]);

% create a tool for inverting (I + detla * D'D)
L = laplaceinv([ny,nx]);
L.setdelta(delta);

% test tool by restoring the image from "test":
restoredImage = L\test;

% verify the result:
sum(abs(restoredImage(:) - img(:)))

% indeed the call "L\" on an image inverts the operator (I+delta D'*D)!

